Macro Extract Wires from Mesh: Difference between revisions

From FreeCAD Documentation
(Created page with "<translate> {{Macro|Icon=Text-x-python|Name=Macro Extract Wires from Mesh|Description=Extracts boundary wires from selected meshes|Author=Yorik|Version=1}} ==Description==...")
 
(Marked this version for translation)
Line 1: Line 1:
<translate>
<translate>


<!--T:1-->
{{Macro|Icon=Text-x-python|Name=Macro Extract Wires from Mesh|Description=Extracts boundary wires from selected meshes|Author=Yorik|Version=1}}
{{Macro|Icon=Text-x-python|Name=Macro Extract Wires from Mesh|Description=Extracts boundary wires from selected meshes|Author=Yorik|Version=1}}


==Description==
==Description== <!--T:2-->


<!--T:3-->
Finds boundary wires in selected mesh objects. Boundary wires are formed from all the edges found in the mesh that are shared by only one face, that is, they are "border" edges. The found wires get added to the document (one compound per mesh object), while the mesh itself gets hidden.
Finds boundary wires in selected mesh objects. Boundary wires are formed from all the edges found in the mesh that are shared by only one face, that is, they are "border" edges. The found wires get added to the document (one compound per mesh object), while the mesh itself gets hidden.


==Script==
==Script== <!--T:4-->
</translate>
</translate>
{{Code|code=#!/usr/bin/python
{{Code|code=#!/usr/bin/python

Revision as of 16:35, 21 December 2016

File:Text-x-python Macro Extract Wires from Mesh

Description
Extracts boundary wires from selected meshes

Macro version: 1
Author: Yorik
Author
Yorik
Download
None
Links
Macro Version
1
Date last modified
None
FreeCAD Version(s)
None
Default shortcut
None
See also
None

Description

Finds boundary wires in selected mesh objects. Boundary wires are formed from all the edges found in the mesh that are shared by only one face, that is, they are "border" edges. The found wires get added to the document (one compound per mesh object), while the mesh itself gets hidden.

Script

#!/usr/bin/python

# This macro will extract wires from selected meshes
# The result is a new Part Compound containing wires, one per original mesh object
# The selected meshes will be hidden but still selected after the operation.
# Warning, it takes a bit of time...

import FreeCAD,FreeCADGui,Part,Draft,DraftGeomUtils,Mesh
for obj in FreeCADGui.Selection.getSelection():
    if obj.isDerivedFrom("Mesh::Feature"):
        shape = Part.Shape()
        shape.makeShapeFromMesh(obj.Mesh.Topology,0.1)
        edges = []
        lut = {}
        for f in shape.Faces:
            for e in f.Edges:
                lut.setdefault(e.hashCode(),[]).append(e)
        for k,v in lut.items():
            if len(v) == 1:
                edges.extend(v)
        if edges:
            wires = DraftGeomUtils.findWires(edges)
            if wires:
                Part.show(Part.makeCompound(wires))
                obj.ViewObject.hide()
Other languages: